Package net.sf.saxon.expr

## Class UserFunctionCall

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.FunctionCall
    - - net.sf.saxon.expr.UserFunctionCall

- All Implemented Interfaces:
    `ComponentInvocation`, `ContextOriginator`, `ExportAgent`, `Locatable`, `UserFunctionResolvable`, `IdentityComparable`, `Traceable`

      public class UserFunctionCall
      extends FunctionCall
      implements UserFunctionResolvable, ComponentInvocation, ContextOriginator

  This class represents a call to a user-defined function in the stylesheet or query.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `FOREIGN_TAIL_CALL` |
    `static int` | `NOT_TAIL_CALL` |
    `static int` | `SELF_TAIL_CALL` |

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `UserFunctionCall()` | Create a function call to a user-written function in a query or stylesheet

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `void` | `allocateArgumentEvaluators()` |
    `int` | `computeCardinality()` | Determine the cardinality of the result
    `protected int` | `computeSpecialProperties()` | Compute the special properties of this expression.
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `Sequence[]` | `evaluateArguments​(XPathContext c)` |
    `Sequence[]` | `evaluateArguments​(XPathContext c, boolean streamed)` |
    `Item` | `evaluateItem​(XPathContext c)` | Call the function, returning the value as an item.
    `void` | `evaluatePendingUpdates​(XPathContext context, PendingUpdateList pul)` | Evaluate an updating expression, adding the results to a Pending Update List.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `Evaluator[]` | `getArgumentEvaluators()` |
    `int` | `getBindingSlot()` | Get the binding slot to be used.
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `Component` | `getFixedTarget()` | Get the target component if this is known in advance, that is, if the target component is private or final, or in some other cases such as xsl:original.
    `UserFunction` | `getFunction()` | Get the function that is being called by this function call.
    `StructuredQName` | `getFunctionName()` | Get the qualified of the function being called
    `int` | `getImplementationMethod()` | An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `int` | `getIntrinsicDependencies()` | Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
    `ItemType` | `getItemType()` | Determine the data type of the expression, if possible
    `StructuredQName` | `getObjectName()` | Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `java.lang.Object` | `getProperty​(java.lang.String name)` |
    `UType` | `getStaticUType​(UType contextItemType)` | Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
    `SymbolicName` | `getSymbolicName()` | Get the symbolic name of the component that this invocation references
    `Component` | `getTarget()` |
    `Component` | `getTargetComponent​(XPathContext context)` |
    `UserFunction` | `getTargetFunction​(XPathContext context)` | Get the target function to be called
    `boolean` | `isBeingInlined()` |
    `boolean` | `isRecursiveTailCall()` |
    `boolean` | `isTailCall()` | Determine whether this is a tail call (not necessarily a recursive tail call)
    `boolean` | `isUpdatingExpression()` | Determine whether this is an updating expression as defined in the XQuery update specification
    `SequenceIterator` | `iterate​(XPathContext c)` | Call the function, returning an iterator over the results.
    `int` | `markTailFunctionCalls​(StructuredQName qName, int arity)` | Mark tail-recursive calls on stylesheet functions.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `Expression` | `preEvaluate​(ExpressionVisitor visitor)` | Pre-evaluate a function at compile time.
    `void` | `process​(Outputter output, XPathContext context)` | Process the function call in push mode
    `void` | `resetLocalStaticProperties()` | Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.
    `void` | `setArgumentEvaluationModes​(EvaluationMode[] evalModes)` | Set the argument evaluation modes
    `void` | `setBeingInlined​(boolean beingInlined)` |
    `void` | `setBindingSlot​(int slot)` | Set the binding slot to be used.
    `void` | `setFunction​(UserFunction compiledFunction)` | Create the reference to the function to be called
    `void` | `setFunctionName​(StructuredQName name)` | Set the name of the function being called
    `void` | `setStaticType​(SequenceType type)` | Set the static type
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Type-check the expression.

    - ### Methods inherited from class net.sf.saxon.expr.FunctionCall

      `addExternalFunctionCallToPathMap, adjustRequiredType, checkArgumentCount, checkArguments, checkFunctionCall, computeHashCode, equals, getArg, getArguments, getArity, getDisplayName, getNetCost, getOperanda, operands, pluralArguments, preEvaluateIfConstant, setArg, setArguments, setOperanda, setOperanda, simplifyArguments, toShortString, toString`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, effectiveBooleanValue, evaluateAsString, explain, getCardinality, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getLocalRetainedStaticContext, getLocation, getPackageData, getParentExpression, getProperties, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStreamerName, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isInstruction, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isVacuousExpression, operandList, operandSparseList, optimizeChildren, prepareForStreaming, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Field Detail

    - #### NOT_TAIL_CALL

          public static final int NOT_TAIL_CALL

      See Also:
        Constant Field Values

    - #### FOREIGN_TAIL_CALL

          public static final int FOREIGN_TAIL_CALL

      See Also:
        Constant Field Values

    - #### SELF_TAIL_CALL

          public static final int SELF_TAIL_CALL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### UserFunctionCall

          public UserFunctionCall()

      Create a function call to a user-written function in a query or stylesheet

  - ### Method Detail

    - #### isBeingInlined

          public boolean isBeingInlined()

    - #### setBeingInlined

          public void setBeingInlined​(boolean beingInlined)

    - #### setFunctionName

          public final void setFunctionName​(StructuredQName name)

      Set the name of the function being called
      Parameters:
        `name` - the name of the function

    - #### setStaticType

          public void setStaticType​(SequenceType type)

      Set the static type
      Parameters:
        `type` - the static type of the result of the function call

    - #### setFunction

          public void setFunction​(UserFunction compiledFunction)

      Create the reference to the function to be called
      Specified by:
        `setFunction` in interface `UserFunctionResolvable`
      Parameters:
        `compiledFunction` - the function being called

    - #### setBindingSlot

          public void setBindingSlot​(int slot)

      Set the binding slot to be used. This is the offset within the binding vector of the containing component where the actual target template is to be found. The target function is not held directly in the UserFunctionCall expression itself because it can be overridden in a using package.
      Specified by:
        `setBindingSlot` in interface `ComponentInvocation`
      Parameters:
        `slot` - the offset in the binding vector of the containing package where the target template can be found.

    - #### getBindingSlot

          public int getBindingSlot()

      Get the binding slot to be used. This is the offset within the binding vector of the containing component where the actual target template is to be found.
      Specified by:
        `getBindingSlot` in interface `ComponentInvocation`
      Returns:
        the offset in the binding vector of the containing package where the target template can be found.

    - #### getFunction

          public UserFunction getFunction()

      Get the function that is being called by this function call. This is the provisional binding: the actual function might be an override of this one.
      Returns:
        the function being called

    - #### getFixedTarget

          public Component getFixedTarget()

      Description copied from interface: `ComponentInvocation`
      Get the target component if this is known in advance, that is, if the target component is private or final, or in some other cases such as xsl:original. Otherwise, return null.
      Specified by:
        `getFixedTarget` in interface `ComponentInvocation`
      Returns:
        the bound component if the binding has been fixed

    - #### isTailCall

          public boolean isTailCall()

      Determine whether this is a tail call (not necessarily a recursive tail call)
      Returns:
        true if this function call is a tail call

    - #### isRecursiveTailCall

          public boolean isRecursiveTailCall()

    - #### getFunctionName

          public final StructuredQName getFunctionName()

      Get the qualified of the function being called
      Specified by:
        `getFunctionName` in class `FunctionCall`
      Returns:
        the qualified name

    - #### getSymbolicName

          public SymbolicName getSymbolicName()

      Description copied from interface: `ComponentInvocation`
      Get the symbolic name of the component that this invocation references
      Specified by:
        `getSymbolicName` in interface `ComponentInvocation`
      Returns:
        the symbolic name of the target component, or null if there is no component referenced

    - #### getTarget

          public Component getTarget()

    - #### setArgumentEvaluationModes

          public void setArgumentEvaluationModes​(EvaluationMode[] evalModes)

      Set the argument evaluation modes
      Parameters:
        `evalModes` - the argument evaluation modes to be used

    - #### allocateArgumentEvaluators

          public void allocateArgumentEvaluators()

    - #### getArgumentEvaluators

          public Evaluator[] getArgumentEvaluators()

    - #### preEvaluate

          public Expression preEvaluate​(ExpressionVisitor visitor)

      Pre-evaluate a function at compile time. This version of the method suppresses early evaluation by doing nothing.
      Overrides:
        `preEvaluate` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the result of the early evaluation, or the original expression, or potentially a simplified expression

    - #### getItemType

          public ItemType getItemType()

      Determine the data type of the expression, if possible
      Specified by:
        `getItemType` in class `Expression`
      Returns:
        Type.ITEM (meaning not known in advance)

    - #### getStaticUType

          public UType getStaticUType​(UType contextItemType)

      Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
      Overrides:
        `getStaticUType` in class `Expression`
      Parameters:
        `contextItemType` - the static type of the context item
      Returns:
        the static item type of the expression according to the XSLT 3.0 defined rules

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Description copied from class: `Expression`
      Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### isUpdatingExpression

          public boolean isUpdatingExpression()

      Determine whether this is an updating expression as defined in the XQuery update specification
      Overrides:
        `isUpdatingExpression` in class `Expression`
      Returns:
        true if this is an updating expression

    - #### computeSpecialProperties

          protected int computeSpecialProperties()

      Compute the special properties of this expression. These properties are denoted by a bit-significant integer, possible values are in class `StaticProperty`. The "special" properties are properties other than cardinality and dependencies, and most of them relate to properties of node sequences, for example whether the nodes are in document order.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        the special properties, as a bit-significant integer

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - variable bindings that need to be changed
      Returns:
        the copy of the original expression

    - #### computeCardinality

          public int computeCardinality()

      Determine the cardinality of the result
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`. May also return `StaticProperty.ALLOWS_ZERO` if the result is known to be an empty sequence, or `StaticProperty.ALLOWS_MANY` if if is known to return a sequence of length two or more.

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `FunctionCall`
      Type-check the expression. This also calls preEvaluate() to evaluate the function if all the arguments are constant; functions that do not require this behavior can override the preEvaluate method.
      Overrides:
        `typeCheck` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `FunctionCall`
      Perform optimisation of an expression and its subexpressions.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### resetLocalStaticProperties

          public void resetLocalStaticProperties()

      Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.
      Overrides:
        `resetLocalStaticProperties` in class `Expression`

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### markTailFunctionCalls

          public int markTailFunctionCalls​(StructuredQName qName,
                                           int arity)

      Mark tail-recursive calls on stylesheet functions. This marks the function call as tailRecursive if if is a call to the containing function, and in this case it also returns "true" to the caller to indicate that a tail call was found.
      Overrides:
        `markTailFunctionCalls` in class `Expression`
      Parameters:
        `qName` - the name of the function
        `arity` - the arity (number of parameters) of the function
      Returns:
        `NOT_TAIL_CALL` if no tail call was found; `FOREIGN_TAIL_CALL` if a tail call on a different function was found; `SELF_TAIL_CALL` if a tail recursive call was found and if this call accounts for the whole of the value.

    - #### getImplementationMethod

          public int getImplementationMethod()

      Description copied from class: `FunctionCall`
      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.
      Overrides:
        `getImplementationMethod` in class `FunctionCall`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### evaluateItem

          public Item evaluateItem​(XPathContext c)
                            throws XPathException

      Call the function, returning the value as an item. This method will be used only when the cardinality is zero or one. If the function is tail recursive, it returns an Object representing the arguments to the next (recursive) call
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `c` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterate

          public SequenceIterator iterate​(XPathContext c)
                                   throws XPathException

      Call the function, returning an iterator over the results. (But if the function is tail recursive, it returns an iterator over the arguments of the recursive call)
      Overrides:
        `iterate` in class `FunctionCall`
      Parameters:
        `c` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates​(XPathContext context,
                                             PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails

    - #### process

          public void process​(Outputter output,
                              XPathContext context)
                       throws XPathException

      Process the function call in push mode
      Overrides:
        `process` in class `Expression`
      Parameters:
        `output` - the destination for the result
        `context` - the XPath dynamic context
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getTargetComponent

          public Component getTargetComponent​(XPathContext context)

    - #### getTargetFunction

          public UserFunction getTargetFunction​(XPathContext context)

      Description copied from class: `FunctionCall`
      Get the target function to be called
      Specified by:
        `getTargetFunction` in class `FunctionCall`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        the target function

    - #### evaluateArguments

          public Sequence[] evaluateArguments​(XPathContext c)
                                       throws XPathException

      Overrides:
        `evaluateArguments` in class `FunctionCall`
      Throws:
        `XPathException`

    - #### evaluateArguments

          public Sequence[] evaluateArguments​(XPathContext c,
                                              boolean streamed)
                                       throws XPathException

      Throws:
        `XPathException`

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Overrides:
        `export` in class `FunctionCall`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `FunctionCall`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### getProperty

          public java.lang.Object getProperty​(java.lang.String name)

      Overrides:
        `getProperty` in class `Expression`

    - #### getObjectName

          public StructuredQName getObjectName()

      Description copied from interface: `Traceable`
      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.
      Specified by:
        `getObjectName` in interface `Traceable`
      Overrides:
        `getObjectName` in class `Expression`
      Returns:
        the QName of the object declared or manipulated by this instruction or expression